Ruby - Feature #859

open-uri doesn't allow redirection to https
12/12/2008 03:16 AM - romanbsd (Roman Shterenzon)

Status: Closed

Priority: Normal
Assignee: akr (Akira Tanaka)
Target version:

Description

=begin

Only ftp and http are checked in regex in OpenURI.redirectable? method.
Please see the attached patch.

=end

Associated revisions

Revision 393ecc9f10016828a3713438ae216dc39b965364 - 09/07/2016 07:14 AM - akr (Akira Tanaka)

lib/open-uri.rb: Allow http to https redirection.
e lib/open-uri.rb: Allow http to https redirection.
Note that https to http is still forbidden.
[ruby-core:20485] [Feature #859] by Roman Shterenzon.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56085 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 393ecc9f - 09/07/2016 07:14 AM - akr (Akira Tanaka)
lib/open-uri.rb: Allow http to https redirection.
e lib/open-uri.rb: Allow http to https redirection.
Note that https to http is still forbidden.
[ruby-core:20485] [Feature #859] by Roman Shterenzon.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56085 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/03/2009 10:57 AM - shyouhei (Shyouhei Urabe)

- Assignee set to akr (Akira Tanaka)

=begin

=end

#2 - 02/03/2009 10:58 AM - akr (Akira Tanaka)

- ruby -v set to -

=begin
ruby-core:21203

=end

#3 - 02/03/2009 05:50 PM - romanbsd (Roman Shterenzon)

=begin

Originally reported on:

ruby 1.8.7 (2008-08-11 patchlevel 72) [i686-linux]
=end

#4 - 02/03/2009 05:53 PM - romanbsd (Roman Shterenzon)

=begin
| quote from [ruby-core:21234] :

But first of all the HTTP --> HTTPS redirection should be still considered ok.
https://blade.ruby-lang.org/ruby-core/21203
https://blade.ruby-lang.org/ruby-core/21234

Regarding the other way, well, the Referer should be set to the URL that redirected us. | believe this is not currently implemented. As for cookies,
AFAIK there's no direct support for cookies in Net::HTTP nor open-uri, so if the programmer wants to use cookies, she has to set it manually via a
"Cookie" header. And since no support for cookies as per RFC2109 is in place, no security measures are implemented. So for example one URL can
redirect to other (also HTTP) URL, which is in another domain, and the cookie (actually header) will be sent anyway. So the fact that the "secure"
attribute of cookie is unsupported diminishes in light of this. Therefor | think that redirecting from HTTPS to HTTP should be considered ok too.

=end

#5 - 09/02/2009 11:48 AM - nobu (Nobuyoshi Nakada)

=begin
Hi,

At Tue, 3 Feb 2009 17:53:36 +0900,
Roman Shterenzon wrote in [ruby-core:21797]:

| quote from [ruby-core:21234] :

But first of all the HTTP --> HTTPS redirection should be still considered ok.

Then your previous patch is wrong.

Index: lib/open-uri.rb

--- lib/open-uri.rb (revision 24735)
+++ lib/open-uri.rb (working copy)
@@ -241,5 +241,5 @@ module OpenURI
# However this is ad hoc. It should be extensible/configurable.
uri1.scheme.downcase == uri2.scheme.downcase ||
e (AA(?:http|ftp)\z/i =~ uri1.scheme && NA(?:httplftp)\z/i =~ uri2.scheme)

o (AA(?:http|ftp)\z/i =~ uri1.scheme && NA(?:https?|ftp)\z/i =~ uri2.scheme)
end

Nobu Nakada

=end

#6 - 09/04/2009 08:01 AM - shyouhei (Shyouhei Urabe)
- Status changed from Open to Closed

=begin

=end

#7 - 05/18/2011 02:41 PM - xaviershay (Xavier Shay)

Why was this closed? This bug is still present in trunk. A patch was reverted in r21381, but it was not the patch that Nobuyoshi has proposed, and
there was no indication as to why it was reverted (my guess is because it allowed https -> http redirection).

#8 - 05/18/2011 02:51 PM - naruse (Yui NARUSE)
- Status changed from Closed to Assigned

- Priority changed from 3 to Normal

#9 - 06/26/2011 04:37 PM - nahi (Hiroshi Nakamura)

- Target version set to 1.9.3

Tanaka-san, please handle this.

#10 - 07/28/2011 11:21 PM - nahi (Hiroshi Nakamura)

Akr, | think we agreed that http -> https redirection is OK. If you don't like ad-hoc change for 1.9.3, | can do that uglish thing instead of you. :) Do you

mind if I'd do that?

#11 - 08/01/2011 10:18 PM - akr (Akira Tanaka)

- Target version changed from 1.9.3 to 2.0.0
I'd like generic solution. Especially because open-uri doesn't provide a way to specify headers for each request for redirection.

#12 - 12/04/2012 01:28 AM - jaimeiniesta (Jaime Iniesta)

I've packed this patch as a gem:

https://github.com/jaimeiniesta/open_uri_redirections

#13 - 12/09/2012 09:17 PM - mame (Yusuke Endoh)

- Tracker changed from Bug to Feature

#14 - 12/09/2012 09:17 PM - mame (Yusuke Endoh)

- Target version changed from 2.0.0 to 2.6

#15 - 10/31/2014 10:00 AM - naruse (Yui NARUSE)
FYI, HTML5 defines whether it should redirect or not:

http://www.w3.0rg/TR/2014/REC-htmI5-20141028/infrastructure.html#processing-model

#16 - 08/28/2016 11:51 AM - cabo (Carsten Bormann)

A typical example of the consequences of this 7-year old bug is https:/github.com/cabo/kramdown-rfc2629/issues/27

Please wake up and fix this. Now.

#17 - 09/07/2016 07:14 AM - akr (Akira Tanaka)

- Status changed from Assigned to Closed

Applied in changeset r56085.

lib/open-uri.rb: Allow http to https redirection.

e |ib/open-uri.rb: Allow http to https redirection.
Note that https to http is still forbidden.
ruby-core:20485] [Feature #859] by Roman Shterenzon.

Files
